<?php 
include "common/header.php";
?>
<!-- body -->

<h1>IMS LTI 1.1 Developer Support</h1>
<p>
Welcome to our developer support web site for Learning Tools Interoperability (LTI).   
There is no account needed for these resources.  This site is supported by IMS members, 
if you would like to help support this site, please join the 
<a href="http://www.imsglobal.org/register/login.cfm">IMS Community</a> (free) or becoming a 
<a href="http://www.imsglobal.org/joinims.html">IMS Member</a> at one of several levels.
</p>
<h2>Documentation</h2>
<p>
These are supporting materials and presentations regarding LTI. The formal specification
for IMS LTI is available in the 
<a href="http://www.imsglobal.org/specifications.html">specification download area</a>.
<p>
<ul>
<li><a href="docs/LTI_Primer_1_1.pdf">LTI Primer</a> (handout)
</li>
<li>LTI Overview
(<a href="http://www.imsglobal.org/developers/LTI/test/v1p1/docs/LTI_Overview_1_1.pdf"
   target="_new">Presentation</a>)
(<a href="http://www.vimeo.com/34168694" target="_new">Recorded Video</a>)
</li>
<li>
Developing LTI Applications in PHP
(<a href="http://www.imsglobal.org/developers/BLTI/materials/2010-05-20-blti-php-02.pdf">Presentation</a>)
</li>
<li>
<a href="http://oauth.googlecode.com/svn/spec/ext/body_hash/1.0/oauth-bodyhash.html"
target="_new">OAuth Request Body Hash Specification</a>
</li>
</ul>
</p>
<h2>Tools for Testing</h2>
<p>
<ul>
<li><a href="lms.php">Simple Consumer</a> - A simple LMS to exercise your LTI tool.
</li>
<li><a href="tool.php">Simple Provider</a> - A simple tool to exercise your LMS or other software
that wants to do a  LTI Launch.</li>
</ul>
</p>
<h2>Certification</h2>
<p>
Tool Consumers (LMSs) and Tool Providers (External Tools) cannot legally 
claim to "comply"  with the LTI specification unless the vendor is an IMS 
Member and passes the IMS-provided certification tests and received confirmation
of their certification from IMS.
<ul>
<li> <a href="http://www.imsglobal.org/cc/statuschart.html">List of Certified Products</a> </li>
<li> <a href="http://vimeo.com/34228293" target="_new">How to Certify an LMS</a> (Video) </li>
<li> <a href="http://vimeo.com/34229715" target="_new">How to Certify an External Tool</a> (Video)</li>
<li> <a href="http://www.youtube.com/watch?v=DXVXGPv1B1Q" target="_new">Certifing MyOpenMath (Tool)</a> (Video courtesy of David Lippman)</li>
<li> <a href="http://www.imsglobal.org/joinims.html">Joining IMS</a> </li>
<li> <a href="http://www.imsglobal.org/developers/alliance/LTI/cert-v1p1/">Start your 
Certification (Members only)</a></li>
</ul>
<h2>Support</h2>
<p>
<ul>
<li>You can join the IMS <a href="http://www.imsglobal.org/community/forum/index.cfm?forumid=11" target="_new">IMS Community Forum</a> (free community account required)</li>
<li>IMS Members participate in standards development, get support and assistance from IMS 
staff, and can apply for certification for their products.  For more information on IMS 
Membership, visit the <a href="http://www.imsglobal.org/joinims.html">Join IMS</a> page.
<li>If you a member of the IMS Alliance you can visit the <a href="http://www.imsglobal.org/community/forum/index.cfm?forumid=7" target="_new">IMS Alliance Forum</a> to get support from
IMS staff.</li>
</ul>
</p>
<h2>IMS LTI 1.0 (Basic)</h2>
<p>
You can view the documentation for 
<a href="http://www.imsglobal.org/developers/BLTI/">
IMS Learning Tools Interoperability 1.0 (Basic LTI)</a>.
</p>

<?php
include "common/footer.php";
?>
